
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>ram: Go Coverage Report</title>
		<style>
			body {
				background: black;
				color: rgb(80, 80, 80);
			}
			body, pre, #legend span {
				font-family: Menlo, monospace;
				font-weight: bold;
			}
			#topbar {
				background: black;
				position: fixed;
				top: 0; left: 0; right: 0;
				height: 42px;
				border-bottom: 1px solid rgb(80, 80, 80);
			}
			#content {
				margin-top: 50px;
			}
			#nav, #legend {
				float: left;
				margin-left: 10px;
			}
			#legend {
				margin-top: 12px;
			}
			#nav {
				margin-top: 10px;
			}
			#legend span {
				margin: 0 5px;
			}
			.cov0 { color: rgb(192, 0, 0) }
.cov1 { color: rgb(128, 128, 128) }
.cov2 { color: rgb(116, 140, 131) }
.cov3 { color: rgb(104, 152, 134) }
.cov4 { color: rgb(92, 164, 137) }
.cov5 { color: rgb(80, 176, 140) }
.cov6 { color: rgb(68, 188, 143) }
.cov7 { color: rgb(56, 200, 146) }
.cov8 { color: rgb(44, 212, 149) }
.cov9 { color: rgb(32, 224, 152) }
.cov10 { color: rgb(20, 236, 155) }

		</style>
	</head>
	<body>
		<div id="topbar">
			<div id="nav">
				<select id="files">
				
				<option value="file0">example.com/ram/expireat.go (73.3%)</option>
				
				</select>
			</div>
			<div id="legend">
				<span>not tracked</span>
			
				<span class="cov0">not covered</span>
				<span class="cov8">covered</span>
			
			</div>
		</div>
		<div id="content">
		
		<pre class="file" id="file0" style="display: none">// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the 'License');
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an 'AS IS' BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package main

import (
        "context"
        "fmt"
        "log"
        "strings"
        "time"

        "cloud.google.com/go/firestore"
        "github.com/kelseyhightower/envconfig"
)

const microserviceName = "publish2fs"

func main() <span class="cov0" title="0">{
        err := addExpireAtWhenMissing(1000)
        if err != nil </span><span class="cov0" title="0">{
                log.Fatalf("%v\n", err)
        }</span>
}

func addExpireAtWhenMissing(pageSize int) (err error) <span class="cov8" title="1">{
        var env struct {
                AssetCollectionID       string `envconfig:"asset_collection_id" default:"assets"`
                AssetRetentionExemption string `envconfig:"asset_retention_exemption" default:"cloudresourcemanager.googleapis.com/"`
                ProjectID               string `envconfig:"project_id" required:"true"`
        }
        err = envconfig.Process(microserviceName, &amp;env)
        if err != nil </span><span class="cov0" title="0">{
                return err
        }</span>

        <span class="cov8" title="1">var ctx = context.Background()
        firestoreClient, err := firestore.NewClient(ctx, env.ProjectID)
        if err != nil </span><span class="cov0" title="0">{
                return err
        }</span>

        <span class="cov8" title="1">myQuery := firestoreClient.Collection(env.AssetCollectionID).
                Where("asset.assetType", "not-in", []string{"cloudresourcemanager.googleapis.com/Project", "cloudresourcemanager.googleapis.com/Folder", "cloudresourcemanager.googleapis.com/Organization"})

        firstPage := myQuery.
                Limit(pageSize).
                Documents(ctx)

        docs, err := firstPage.GetAll()
        if err != nil </span><span class="cov0" title="0">{
                return err
        }</span>
        <span class="cov8" title="1">for </span><span class="cov8" title="1">{
                if len(docs) &gt; 0 </span><span class="cov8" title="1">{
                        for _, doc := range docs </span><span class="cov8" title="1">{
                                // log.Println(doc.Ref.Path)
                                assetMap := doc.Data()
                                var assetInterface interface{} = assetMap["asset"]
                                if asset, ok := assetInterface.(map[string]interface{}); ok </span><span class="cov8" title="1">{
                                        var nameInterface interface{} = asset["name"]
                                        if name, ok := nameInterface.(string); ok </span><span class="cov8" title="1">{
                                                var assetTypeInterface interface{} = asset["assetType"]
                                                if assetType, ok := assetTypeInterface.(string); ok </span><span class="cov8" title="1">{
                                                        if !strings.Contains(assetType, env.AssetRetentionExemption) </span><span class="cov8" title="1">{
                                                                if _, ok := doc.Data()["expireAt"]; !ok </span><span class="cov8" title="1">{
                                                                        _, err := doc.Ref.Update(ctx, []firestore.Update{
                                                                                {
                                                                                        Path:  "expireAt",
                                                                                        Value: time.Now(), // This will be stored as a Firestore timestamp
                                                                                },
                                                                        })
                                                                        if err != nil </span><span class="cov0" title="0">{
                                                                                return fmt.Errorf("failed to update document: %s %v", doc.Ref.Path, err)
                                                                        }</span>
                                                                        <span class="cov8" title="1">log.Printf("added expireAt: %s", name)</span>
                                                                } else<span class="cov8" title="1"> {
                                                                        log.Printf("already have expireAt: %s", name)
                                                                }</span>
                                                        } else<span class="cov0" title="0"> {
                                                                log.Printf("exempted asset: %s", name)
                                                        }</span>
                                                } else<span class="cov0" title="0"> {
                                                        log.Printf("missing assetType: %s", name)
                                                }</span>
                                        } else<span class="cov0" title="0"> {
                                                log.Printf("missing assetName: %s", doc.Ref.Path)
                                        }</span>
                                } else<span class="cov0" title="0"> {
                                        log.Printf("not an asset doc: %s", doc.Ref.Path)
                                }</span>
                        }
                        <span class="cov8" title="1">lastDoc := docs[len(docs)-1]
                        myQuery = myQuery.StartAfter(lastDoc)
                        page := myQuery.
                                Limit(pageSize).
                                Documents(ctx)

                        docs, err = page.GetAll()
                        if err != nil </span><span class="cov0" title="0">{
                                return err
                        }</span>
                } else<span class="cov8" title="1"> {
                        break</span>
                }
        }
        <span class="cov8" title="1">return nil</span>
}
</pre>
		
		</div>
	</body>
	<script>
	(function() {
		var files = document.getElementById('files');
		var visible;
		files.addEventListener('change', onChange, false);
		function select(part) {
			if (visible)
				visible.style.display = 'none';
			visible = document.getElementById(part);
			if (!visible)
				return;
			files.value = part;
			visible.style.display = 'block';
			location.hash = part;
		}
		function onChange() {
			select(files.value);
			window.scrollTo(0, 0);
		}
		if (location.hash != "") {
			select(location.hash.substr(1));
		}
		if (!visible) {
			select("file0");
		}
	})();
	</script>
</html>
